"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var Rx_1 = require('rxjs/Rx');
var SimpleMQ = (function () {
    function SimpleMQ() {
        this.uuid = require('node-uuid');
        this.mq = {};
        this.subscription = {};
    }
    SimpleMQ.prototype.getQueue = function () {
        return Object.keys(this.mq);
    };
    SimpleMQ.prototype.getSubscription = function () {
        return Object.keys(this.subscription);
    };
    SimpleMQ.prototype.newQueue = function (name) {
        if (name === undefined || this.mq[name]) {
            return false;
        }
        var s = new Rx_1.Subject();
        var o = s.asObservable();
        this.mq[name] = { subject: s, observable: o };
        return true;
    };
    SimpleMQ.prototype.delQueue = function (name) {
        var _this = this;
        if (name === undefined || !this.mq['name']) {
            return false;
        }
        var s = this.getSubscription();
        s.forEach(function (i) {
            if (_this.subscription[i].name === name) {
                _this.unsubscribe(i);
            }
        });
        delete this.mq[name].observable;
        delete this.mq[name].subject;
        delete this.mq[name];
    };
    SimpleMQ.prototype.publish = function (name, msg, lazy) {
        if (lazy === void 0) { lazy = true; }
        if (msg === undefined || name === undefined) {
            return false;
        }
        if (lazy) {
            this.newQueue(name);
        }
        else if (!this.mq[name]) {
            return false;
        }
        this.mq[name].subject.next(msg);
        return true;
    };
    SimpleMQ.prototype.subscribe = function (name, callback, lazy) {
        if (lazy === void 0) { lazy = true; }
        if (name === undefined || callback === undefined) {
            return '';
        }
        if (lazy) {
            this.newQueue(name);
        }
        else if (!this.mq[name]) {
            return '';
        }
        var id = name + '-' + this.uuid.v1();
        this.subscription[id] = {
            name: name,
            subscription: this.mq[name].observable.subscribe(callback)
        };
        return id;
    };
    SimpleMQ.prototype.unsubscribe = function (id) {
        if (id === undefined || !this.subscription[id]) {
            return false;
        }
        this.subscription[id].subscription.unsubscribe();
        delete this.subscription[id];
    };
    SimpleMQ = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], SimpleMQ);
    return SimpleMQ;
}());
exports.SimpleMQ = SimpleMQ;
//# sourceMappingURL=simple-mq.js.map